var lC, lK, lz, lR, lWC, a;
varexo exz exa;

parameters beta, phi, gamma, delta, z_bar, rho;

beta = -log(.99);
phi = .95;
gamma = .33;
delta = 0.02;
rho = 2/3;
alpha_bar = 15;
z_bar = (1-alpha_bar)/(1-rho);

model;
(exp(lz*(-beta-rho*(lC(+1)+a(+1)-lC-a))) * exp((lz-1)*lR(+1))) * 
        (gamma*exp((1-gamma)*(a(+1)-a-lK)) +1-delta)=1;

(exp(lK) +exp(lC))*exp(a-a(-1)) = exp(a-a(-1))^(1-gamma)*exp(lK(-1))^(gamma) + (1-delta)*exp(lK(-1));

a = a(-1) + 0.01*exa;

lz = (1-phi)*z_bar + phi*lz(-1) + 5.031152949374528*exz;

exp(lR) = ((exp(lWC)+1)/exp(lWC(-1)))*exp(lC-lC(-1) + a - a(-1));

exp(lz*(-beta-rho*(lC(+1)+a(+1)-lC-a))) * exp(lz*lR(+1)) = 1;

end;

initval;
lWC = log(1/(exp(beta)-1));
lK = log((((exp(beta)-1+delta)/gamma)^(1/(gamma-1))));
lC = log(((((exp(beta)-1+delta)/gamma)^(1/(gamma-1)))^gamma) - delta*(((exp(beta)-1+delta)/gamma)^(1/(gamma-1))));
a = 0;
lR = beta;
lz =z_bar;
end;

steady;

shocks;
var exz; stderr 1;
var exa; stderr 1;
end;

stoch_simul(order=2, periods=1000,IRF=40,nomoments);





