


clear all
tic
global dep_ gamma_ beta_ rho_ alpha_ n_k n_a poly_ lambda_ lambda2_ 
global theta_ a_min a_max k_min k_max s_eps_ SB_ sigma_ mu_ G_ Gp_ 
global eps_max eps_min n_eps poly_1

for counter=1:1
n_k=5;
n_p=5;

dep_=.02;
gamma_=.33;
beta_=.99^.25;
rho_=1/1.5;
alpha_=14;
s_eps_=.0088;

p_max=.04;
p_min=0;
k_max=log(48);
k_min=log(54);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% get polynomials
points_k=ChebyshevRoots(n_k);
points_p=ChebyshevRoots(n_p);


[k_grid p_grid ]=ndgrid(points_k,points_p);
[k_grid2 p_grid2]=ndgrid(points_k,points_p);

poly_=zeros([n_k,n_p,size(k_grid)]);
poly2_=zeros([n_k,n_p,size(k_grid2)]);
for i_k=0:n_k-1
    for i_p=0:n_p-1
            poly_(i_k+1,i_p+1,:,:)=polyval(ChebyshevPoly(i_k),k_grid)...
                .*polyval(ChebyshevPoly(i_p),p_grid);
            
            poly2_(i_k+1,i_p+1,:,:)=polyval(ChebyshevPoly(i_k),k_grid2)...
                .*polyval(ChebyshevPoly(i_p),p_grid2);
    end
end

global poly_ poly2_ Cpoly
for i=0:max([n_k,n_p])
    Cpoly{i+1}=ChebyshevPoly(i);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end

k_ss=(((1/beta_)-(1-dep_))/gamma_)^(1/(gamma_-1));
i_ss = dep_*k_ss;
c_ss = k_ss^gamma_ -i_ss;

coeffs_I=zeros(n_k,n_p); coeffs_I(1,1)=.0232; coeffs_I(1,2)=-.003; coeffs_I(2,1)=-.0151;
coeffs_V=zeros(n_k,n_p); coeffs_V(1,1)=-1; coeffs_V(1,2)=-.09; coeffs_V(2,1)=.0385;

coeffs=[coeffs_I(:); coeffs_V(:)];

 CB_error(coeffs,poly_,poly2_)
% 
 load coef_1
 coeffs=coef_out;

coef_out = fsolve(@(x)CB_error(x,poly_,poly2_),...
    coeffs,optimset('display','iter','algorithm','levenberg-marquardt','maxiter',160,'tolfun',1e-15)); 

save coef_1 coef_out;

coef_out = fminsearch(@(x) sum(CB_error(x,poly_,poly2_).^2),...
    coeffs,optimset('display','iter','maxiter',2000,'tolx',1e-20)); 


ktropts = optimset('Display','iter','TolCon',1e-12,...
          'GradConstr','off','GradObj','off',...
          'algorithm','interior-point','maxiter',100);
   
coef_out=ktrlink(@fake_obj,coeffs,...
           [],[],[],[],[],[],@(x) constr(x,poly_,poly2_),ktropts);


CB_calc
simulate








